{*************************************}
{                                     }
{       QIP INFIUM SDK                }
{       Copyright(c) Ilham Z.         }
{       ilham@qip.ru                  }
{       http://www.qip.im             }
{                                     }
{*************************************}

unit u_qip_plugin;

interface

uses Windows, SysUtils, ExtCtrls, u_plugin_info, u_plugin_msg, u_common;

const
  PLUGIN_VER_MAJOR = 1;
  PLUGIN_VER_MINOR = 0;
  PLUGIN_NAME      : WideString = 'msgbox';
  PLUGIN_AUTHOR    : WideString = 'Doc.X';
  PLUGIN_DESC      : WideString = '';
  PLUGIN_HINT      : WideString = '';
  xpr=100000;

  Outbox='Outbox\';
  Sent='Sent\';
  SentMan='SentMan\';
  Inbox='Inbox\';
  Outstat='Outstat\';
  Instat='Instat\';

type
  TQipPlugin = class(TInterfacedObject, IQIPPlugin)
  private
    FPluginSvc      : IQIPPluginService;
    FPluginInfo     : TPluginInfo;
    FDllPath        : WideString;
    FTestTimer      : TTimer;
    procedure LoadSuccess(PlugMsg: TPluginMessage);
    procedure CreateControls;
    procedure FreeControls;
    procedure ImRcvdSuccess(PlugMsg: TPluginMessage);
    procedure OnTestTimer(Sender: TObject);
    procedure InstantMsgSend(var PlugMsg: TPluginMessage);
//  procedure LogAdd(const LogText: WideString);
// procedure ContactStatusRcvd(PlugMsg: TPluginMessage);
  public

    constructor Create(const PluginService: IQIPPluginService);
    destructor  Destroy; override;

    function  GetPluginInfo: pPluginInfo; stdcall;
    procedure OnQipMessage(var PlugMsg: TPluginMessage); stdcall;

    function Send(text,uin:widestring;PrId:longint=0):string;
    function GetStat(uin:widestring;PrId:longint=0):string;

  end;
  Tpr=record
      id:longint;
      myUIN:widestring;
    end;

  var
    path:string;
    //prICQ,prQIP:longint;
    pr:array [1..5] of Tpr;

implementation

uses Dialogs, Graphics, Forms, Types, u_lang_ids, DateUtils;

{ TQipPlugin }
{***********************************************************}
constructor TQipPlugin.Create(const PluginService: IQIPPluginService);
begin
  FPluginSvc := PluginService;
end;

{***********************************************************}
destructor TQipPlugin.Destroy;
begin
  inherited;
end;

function TQipPlugin.GetPluginInfo: pPluginInfo;
begin
  Result := @FPluginInfo;
end;

{***********************************************************}
procedure TQipPlugin.OnQipMessage(var PlugMsg: TPluginMessage);
begin
  case PlugMsg.Msg of
    PM_PLUGIN_LOAD_SUCCESS    : LoadSuccess(PlugMsg); {updating FPluginInfo, ONLY!!!}
    PM_PLUGIN_RUN             : CreateControls;
    PM_PLUGIN_QUIT            : FreeControls;
    PM_PLUGIN_DISABLE         : FreeControls;
    PM_PLUGIN_ENABLE          : CreateControls;
    PM_PLUGIN_OPTIONS         : ShowMessage('   =)');
    PM_PLUGIN_WRONG_SDK_VER   : ShowMessage('Wrong SDK version. Core SDK ver. ' + IntToStr(PlugMsg.WParam) + '.' + IntToStr(PlugMsg.LParam));
    PM_PLUGIN_RCVD_IM         : ImRcvdSuccess(PlugMsg);
    PM_PLUGIN_MSG_SEND        : InstantMsgSend(PlugMsg);

  end;
end;



Function GetFile(const FileName : String) : AnsiString;
Var
 F : File;
 FSize : Longint;
begin
 Result:='';
 if not FileExists(FileName) then Exit;
 FileMode:=0;
 AssignFile ( F, FileName);
 Reset(F, 1);
 FSize:=FileSize(F);
 SetLength(Result,FSize);
 BlockRead(F, Result[1],FSize);
 CloseFile(F);
 FileMode:=2;
end;

//   
Procedure SetFile(FileName,text : AnsiString);
Var
 F : textFile;
begin
 FileMode:=0;
 AssignFile ( F, FileName);
 Rewrite(f);
 write( F, text);
 CloseFile(F);
 FileMode:=2;
end;


{***********************************************************}
procedure TQipPlugin.LoadSuccess(PlugMsg: TPluginMessage);
var buf      : array[0..MAX_PATH] of WideChar;
begin
  {Getting and updating Plugin dll path and filling FProtoInfo record}
  GetModuleFileNameW(FPluginInfo.DllHandle, buf, SizeOf(buf));
  FDllPath := buf;
  FPluginInfo.DllPath           := PWideChar(FDllPath);
  
  path:=ExtractFilePath(FDllPath);

  FPluginInfo.QipSdkVerMajor    := QIP_SDK_VER_MAJOR;
  FPluginInfo.QipSdkVerMinor    := QIP_SDK_VER_MINOR;
  FPluginInfo.PlugVerMajor      := PLUGIN_VER_MAJOR;
  FPluginInfo.PlugVerMinor      := PLUGIN_VER_MINOR;
  FPluginInfo.PluginName        := PWideChar(PLUGIN_NAME);
  FPluginInfo.PluginAuthor      := PWideChar(PLUGIN_AUTHOR);
  FPluginInfo.PluginDescription := PWideChar(PLUGIN_DESC);
  FPluginInfo.PluginHint        := PWideChar(PLUGIN_HINT);  
  FPluginInfo.PluginIcon        := 0;//LoadImage(0, IDI_INFORMATION, IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR or LR_SHARED);
end;

{***********************************************************}
procedure TQipPlugin.CreateControls;
var
  s,s1:string;
  i:longint;
begin
  {creating test timer for test purposes}
  FTestTimer          := TTimer.Create(nil);
  FTestTimer.Interval := 1000;
  FTestTimer.OnTimer  := OnTestTimer;
  FTestTimer.Enabled  := True;


  if not fileexists(path+'s.txt') then
    setfile(path+'s.txt',' 1'+#13#10+' 3');

  s:=getfile(path+'s.txt');
  i:=0;
  while (pos(#13#10,s)<>0)or(s<>'') do
  Begin
    inc(i);
    if pos(#13#10,s)<>0 then
      s1:=copy(s,1,pos(#13#10,s)-1) else
      Begin
        s1:=s;
        s:='';
      end;

    s:=copy(s,pos(#13#10,s)+2,length(s));

    Pr[i].id:=xpr+strtoint(copy(s1,pos(' ',s1)+1,length(s1)));
    Pr[i].myUIN:=copy(s1,1,pos(' ',s1)-1);
    //showmessage('-'+Pr[i].myUIN+'-'+inttostr(Pr[i].id)+'-');

  end;






  //prQIP:=
  //prICQ:=xpr+strtoint(copy(s2,pos(' ',s2)+1,length(s2)));

  if not fileexists(path+outbox) then
    createdir(path+outbox);
  if not fileexists(path+inbox) then
    createdir(path+inbox);
  if not fileexists(path+sent) then
    createdir(path+sent);
  if not fileexists(path+sentman) then
    createdir(path+sentman);
  if not fileexists(path+outstat) then
    createdir(path+outstat);
  if not fileexists(path+instat) then
    createdir(path+instat);

end;





{***********************************************************}
procedure TQipPlugin.FreeControls;
begin
  if Assigned(FTestTimer) then FreeAndNil(FTestTimer);
end;

function Date:string;
var
  Dt: TDateTime;
begin
  Dt := Now;
  result:= FormatDateTime('YYYYMMDDHHMMSS', dt);
End;


{***********************************************************}
procedure TQipPlugin.OnTestTimer(Sender: TObject);
var
  sr: TSearchRec;
  text:ansistring;
  pp,id,s:string;
  prX:longint;
begin
  //OutBox
  if FindFirst(Path+Outbox + '*.txt', faAnyFile, SR) = 0 then
  begin
    repeat
      if (SR.Attr <> faDirectory) then
      begin
        pp:=Path+Outbox+sr.Name;
        text:=GetFile(pp);

        prX:=0;
        if sr.Name[1]='#' then
        Begin
          prX:=strtoint(copy(sr.name,2,pos('_',sr.name)-2));
          sr.Name:=copy(sr.name,pos('_',sr.name)+1,length(sr.name));
        end;

        if pos('#',sr.name)=0 then
          id:=copy(sr.Name,1,length(sr.name)-4)else
          id:=copy(sr.Name,1,pos('#',sr.name)-1);
        //logadd(id);
        s:=Send(text,id,prX);
        if s<>'' then
        Begin
          //logadd('mov');
          movefile(Pchar(pp),Pchar(path+sent+copy(sr.Name,1,length(sr.name)-4)+'_'+Date+'_'+s+'.txt'));
        End;
      end;
    until FindNext(SR) <> 0;
    FindClose(SR);
  end;

  //OutStat
  if FindFirst(Path+OutStat + '*.txt', faAnyFile, SR) = 0 then
  begin
    repeat
      if (SR.Attr <> faDirectory) then
      begin
        pp:=Path+Outstat+sr.Name;

        prX:=0;
        if sr.Name[1]='#' then
        Begin
          prX:=strtoint(copy(sr.name,2,pos('_',sr.name)-2));
          sr.Name:=copy(sr.name,pos('_',sr.name)+1,length(sr.name));
        end;

        if pos('#',sr.name)=0 then
          id:=copy(sr.Name,1,length(sr.name)-4)else
          id:=copy(sr.Name,1,pos('#',sr.name)-1);

        s:=GetStat(id);

        movefile(Pchar(pp),Pchar(path+instat+copy(sr.Name,1,length(sr.name)-4)+'_'+Date+'_'+s+'.txt'));

      end;
    until FindNext(SR) <> 0;
    FindClose(SR);
  end;
end;

procedure TQipPlugin.ImRcvdSuccess(PlugMsg: TPluginMessage);
var //PlugMsg1     : TPluginMessage;
    iProtoHandle : LongInt;
    iMsgType     : Byte;
    wSenderAcc,  wMsgText: WideString;
begin
  {Getting protocol handle}
  iProtoHandle := PlugMsg.WParam;

  {Getting account name and msg text of successfuly received instant message}
   wSenderAcc := PWideChar(PlugMsg.LParam);
   wMsgText   := PWideChar(PlugMsg.NParam);
   iMsgType   := PlugMsg.Result;

   if iMsgType=1 then
   Begin
     setfile(path+inbox+wSenderAcc+'_'+Date+'.txt',wMsgText);
   end;
end;

function TQipPlugin.GetStat(uin:widestring;PrId:longint=0):string;
var
  PlugMsg1: TPluginMessage;
  wStatus:widestring;
Begin
  if PrId=0 then
  Begin
    //  
    PrId:=2;
    if (pos('@qip.ru',uin)<>0)and(pos('@qip.ru',uin)=length(uin)-6) then
      PrId:=1;
  end;

  PlugMsg1.Msg    := PM_PLUGIN_GET_CONTACT_ST;
  PlugMsg1.WParam := Pr[PrId].id;
  PlugMsg1.LParam := LongInt(PWideChar(uin));


  PlugMsg1.DllHandle := FPluginInfo.DllHandle;
  FPluginSvc.OnPluginMessage(PlugMsg1);

  if Boolean(PlugMsg1.Result) then
    case PlugMsg1.NParam of
      QIP_STATUS_ONLINE 	   : wStatus := 'ONLINE';
    	QIP_STATUS_INVISIBLE 	 : wStatus := 'INVISIBLE';
    	QIP_STATUS_INVISFORALL : wStatus := 'INVISIBLEFORALL';
      QIP_STATUS_FFC	 	     : wStatus := 'FREEFORCHAT';
      QIP_STATUS_EVIL	       : wStatus := 'EVIL';
      QIP_STATUS_DEPRES      : wStatus := 'DEPRESSION';
      QIP_STATUS_ATHOME		   : wStatus := 'HOME';
      QIP_STATUS_ATWORK		   : wStatus := 'WORK';
      QIP_STATUS_OCCUPIED	   : wStatus := 'OCCUPIED';
    	QIP_STATUS_DND		     : wStatus := 'DND';
      QIP_STATUS_LUNCH		   : wStatus := 'LUNCH';
      QIP_STATUS_AWAY		     : wStatus := 'AWAY';
      QIP_STATUS_NA		       : wStatus := 'NOTAVAILABLE';
      QIP_STATUS_OFFLINE 	   : wStatus := 'OFFLINE';
      QIP_STATUS_NOTINLIST   : wStatus := 'NOTINLIST';
    end else
      wStatus := 'OFFLINE';

  result:=wStatus;
end;


{***********************************************************}
function TQipPlugin.Send(text,uin:widestring;PrId:longint=0):string;
var
  PlugMsg1: TPluginMessage;
  wSenderAcc, wRcvrAcc, wMsgText, wStatus : WideString;
  stat:string;
begin
  if PrId=0 then
  Begin
    //  
    PrId:=2;
    if (pos('@qip.ru',uin)<>0)and(pos('@qip.ru',uin)=length(uin)-6) then
      PrId:=1;
  end;

  wRcvrAcc := uin;
  wMsgText := text;


  //////
  PlugMsg1.Msg    := PM_PLUGIN_GET_CONTACT_ST;
  PlugMsg1.WParam := Pr[PrId].id;
  PlugMsg1.LParam := LongInt(PWideChar(Pr[PrId].myUIN));

  //showmessage( (Pr[PrId].myUIN));

  PlugMsg1.DllHandle := FPluginInfo.DllHandle;
  FPluginSvc.OnPluginMessage(PlugMsg1);

  result:='';

  //         
  stat:=GetStat(Pr[PrId].myUIN,PrId) ;
  if stat='OFFLINE' then
    exit;



  // 
  PlugMsg1.Msg    := PM_PLUGIN_SEND_IM;
  PlugMsg1.WParam := Pr[PrId].id;
  PlugMsg1.LParam := LongInt(PWideChar(wRcvrAcc));
  PlugMsg1.NParam := LongInt(PWideChar(wMsgText));

  PlugMsg1.DllHandle := FPluginInfo.DllHandle;
  FPluginSvc.OnPluginMessage(PlugMsg1);

  //
  if Boolean(PlugMsg1.Result) then
    Result:=stat;


end;

procedure TQipPlugin.InstantMsgSend(var PlugMsg: TPluginMessage);
var aQipMsg : pQipMsgPlugin;
begin
  aQipMsg := pQipMsgPlugin(PlugMsg.WParam);



  

  setfile(path+sentMan+aQipMsg^.RcvrAcc+'_'+Date+'_'+getstat(aQipMsg^.RcvrAcc)+'.txt',aQipMsg^.MsgText);
end;


end.

